--[[----------------------------------------------------------------------]]--
--[[--LostTreasures.lua													--]]--
--[[--See README for more info											--]]--
--[[----------------------------------------------------------------------]]--
LostTreasures = LibStub("AceAddon-3.0"):NewAddon("LostTreasures", "AceEvent-3.0", "AceConsole-3.0")
AceConfigRegistry = LibStub("AceConfigRegistry-3.0")
AceConfigDialog = LibStub("AceConfigDialog-3.0")
LibMapData = LibStub("LibMapData-1.0")

--[[----------------------------------------------------------------------]]--
--[[--Event Handler														--]]--
--[[----------------------------------------------------------------------]]--
function LostTreasures:PLAYER_LOGIN(event)
	LostTreasures:UnregisterEvent(event)
	LostTreasures:DoWaypoints({removeAll = false})
end
LostTreasures:RegisterEvent("PLAYER_LOGIN")

--[[----------------------------------------------------------------------]]--
--[[--Other Functions													--]]--
--[[----------------------------------------------------------------------]]--
function printd(msg)
	if ( _LT.SavedVars.DEBUG ) then
		print("LT: "..msg)
	end
end

--[[----------------------------------------------------------------------]]--
--[[--Core Functions													--]]--
--[[----------------------------------------------------------------------]]--
function LostTreasures:OnInitialize()
	self.db = LibStub("AceDB-3.0"):New("LostTreasuresDB", _LT.defaults)
	_LT.SavedVars = self.db.char
	self:RegisterChatCommand("lt", "HandleCommand")
	self:RegisterChatCommand("losttreasures", "HandleCommand")
end

function LostTreasures:HandleCommand(args)
	local cmd, input = self:GetArgs(args, 2)
	if ( cmd == "reload" ) then
		LostTreasures:DoWaypoints()
		printd("LostTreasures has reloaded!")
	elseif ( cmd == "removeall" ) then
		LostTreasures:DoWaypoints({addAll = false})
		printd("Removed all waypoints.")
	elseif ( cmd == "remove" ) then
		LostTreasures:DoWaypoints({removeAll = false, addAll = false, removePoint = input})
		printd("Removed waypoint. Id: "..input)
	elseif ( cmd == "add" ) then
		LostTreasures:DoWaypoints({removeAll = false, addAll = false, addPoint = input})
		printd("Added waypoint. Id: "..input)
	else
		InterfaceOptionsFrame_OpenToCategory(_LT.NAME)
	end
end

function LostTreasures:DefaultSettings()
	_LT.SavedVars.ENABLED = _LT.defaults.char.ENABLED
	_LT.SavedVars.DEBUG = _LT.defaults.char.DEBUG
	_LT.SavedVars.BLOCK_MINING_PICK = _LT.defaults.char.BLOCK_MINING_PICK
	_LT.SavedVars.USE_MINIMAP = _LT.defaults.char.USE_MINIMAP
	_LT.SavedVars.USE_WORLDMAP = _LT.defaults.char.USE_WORLDMAP
	_LT.SavedVars.SHOW_ALL_WAYPOINTS = _LT.defaults.char.SHOW_ALL_WAYPOINTS
	_LT.SavedVars.SHOW_WAYPOINT_TYPE = _LT.defaults.char.SHOW_WAYPOINT_TYPE
	_LT.SavedVars.USE_ARROW = _LT.defaults.char.USE_ARROW
	_LT.SavedVars.TREASURE_FIRST = _LT.defaults.char.TREASURE_FIRST
	_LT.SavedVars.CAVES_FIRST = _LT.defaults.char.CAVES_FIRST
	_LT.SavedVars.CLEARDISTANCE = _LT.defaults.char.CLEARDISTANCE
end

_LT = {
	NAME = "LostTreasures", 
	VERSION = GetAddOnMetadata("LostTreasures", "Version"), 
	defaults = {
		char = {
			ENABLED = true, 
			DEBUG = false, 
			BLOCK_MINING_PICK = false, 
			
			USE_MINIMAP = true, 
			USE_WORLDMAP = true, 
			SHOW_ALL_WAYPOINTS = false, 
			SHOW_WAYPOINT_TYPE = 1, -- 1 = all, 2 = greys, 3 = rares
			
			USE_ARROW = true, 
			TREASURE_FIRST = true, 
			SHOW_DETAILED_INFO = true, 
			CAVES_FIRST = true, 
			
			CLEARDISTANCE = 3, 
		}, 
	}, 
}